package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.User;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class User_Grid_Main2{
    private String username;
    private String memo;
    private Integer issystem;
    private String userid;
    private String updateman;
    private String userobjecttype;
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Timestamp updatedate;
    private String srfmajortext;


    private String srfdatatype;


    private String srfdataaccaction;


    private String srfkey;


    private Integer validflag;
    public  void fromUser(User sourceEntity)  {
         this.setUsername(sourceEntity.getUsername());
         this.setMemo(sourceEntity.getMemo());
         this.setIssystem(sourceEntity.getIssystem());
         this.setUserid(sourceEntity.getUserid());
         this.setUpdateman(sourceEntity.getUpdateman());
         this.setUserobjecttype(sourceEntity.getUserobjecttype());
         this.setUpdatedate(sourceEntity.getUpdatedate());
         this.setSrfmajortext(sourceEntity.getUsername());
         this.setSrfdatatype(sourceEntity.getUserobjecttype());
         this.setSrfdataaccaction(sourceEntity.getUserid());
         this.setSrfkey(sourceEntity.getUserid());
         this.setValidflag(sourceEntity.getValidflag());
	}

	public static Page<User_Grid_Main2> fromUser(Page<User> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<User_Grid_Main2> targetpage=new Page<User_Grid_Main2>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<User_Grid_Main2> records=new ArrayList<User_Grid_Main2>();
        for(User source:sourcePage.getRecords()) {
            User_Grid_Main2 target=new User_Grid_Main2();
            target.fromUser(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("userid","用户标识"); }});
        columnModelList.add(new HashMap(){ { put("username","用户名称"); }});
        columnModelList.add(new HashMap(){ { put("validflag","是否启用"); }});
        columnModelList.add(new HashMap(){ { put("issystem","系统数据"); }});
        columnModelList.add(new HashMap(){ { put("memo","备注"); }});
        columnModelList.add(new HashMap(){ { put("updateman","更新人"); }});
        columnModelList.add(new HashMap(){ { put("updatedate","更新时间"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<User> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(User source:searchResult.getRecords()) {
            User_Grid_Main2 target=new User_Grid_Main2();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<User> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}